/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITEMPRECODIA                                             */
/* Tabela : ITEMPRECODIA                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITEMPRECODIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITEMPRECODIA
GO

CREATE TRIGGER DTULTATU_ITEMPRECODIA
ON ITEMPRECODIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ITEMPRECODIA', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDTABEPREC='+CDTABEPREC+
                ';'+'DTINIVGPREC='+CONVERT(VARCHAR,DTINIVGPREC,103)+';'+'CDPRODUTO='+CDPRODUTO+';'+'CDPRPAITABPR='+CDPRPAITABPR+
                ';'+'NRDIASEMANPR='+NRDIASEMANPR+';'+'HRINIPRECDIA='+HRINIPRECDIA +';'+'CDTIPOCONSPD='+CDTIPOCONSPD+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ITEMPRECODIA
      SET DTULTATUITPD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(ITEMPRECODIA.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND

            (ISNULL(ITEMPRECODIA.CDTABEPREC,0)   = ISNULL(INSERTED.CDTABEPREC,0))   AND
            (ISNULL(ITEMPRECODIA.DTINIVGPREC,CONVERT(DATETIME,'31/12/1899')) =
               ISNULL(INSERTED.DTINIVGPREC,CONVERT(DATETIME,'31/12/1899')))         AND
            (ISNULL(ITEMPRECODIA.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(ITEMPRECODIA.CDPRPAITABPR,0) = ISNULL(INSERTED.CDPRPAITABPR,0)) AND

            (ISNULL(ITEMPRECODIA.NRDIASEMANPR,0) = ISNULL(INSERTED.NRDIASEMANPR,0)) AND
            (ISNULL(ITEMPRECODIA.HRINIPRECDIA,0) = ISNULL(INSERTED.HRINIPRECDIA,0));
   END;
END;
GO

UPDATE ITEMPRECODIA SET DTULTATUITPD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUITPD IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUITPD' and
            type = 'D')
   ALTER TABLE ITEMPRECODIA DROP CONSTRAINT DEFAULT_DTULTATUITPD
GO

ALTER TABLE ITEMPRECODIA ADD CONSTRAINT DEFAULT_DTULTATUITPD
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUITPD
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ITEMPRECODIA','5.07.005';
GO

